<template src="./template.html"></template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler, redirectPage } from "~/utils/apiHanlers";
import Swal from "sweetalert2";
import { regexEmail } from "~/common/constaint";
import {
  trackEventAddPaymentInfo,
  trackEventPurchased,
} from "~/utils/trackEvent";
import { getSessionId, randomCharacter, setSessionId } from "~/utils/sessionId";
import { loadScript } from "@paypal/paypal-js";
import { onClearSession } from "~/utils/localStorage";
@Component({
  components: {},
})
export default class PaypalCheckoutComponent extends Vue {
  @Prop()
  paymentType!: number;

  @Prop()
  couponCode!: string;

  @Prop()
  slug!: string;

  @Prop()
  listCart!: any;

  @Prop()
  checkout!: any;

  @Prop()
  billingAddress!: any;

  @Prop()
  countryCodePayment!: string;

  @Prop()
  amount!: number;

  @Prop()
  totalPriceAll!: number;

  @Prop()
  isAbandon!: string;

  @Prop()
  loadingPriceShipping!: boolean;

  @Prop()
  isSameAddress!: string;

  bodyPaypal: any = {};

  @Prop()
  errorField: any;

  @Prop()
  isDonePayment!: boolean;

  @Prop()
  tip!: number;

  mounted() {
    this.setScriptPaypal();
  }

  async setScriptPaypal() {
    if (this.publicKeyPaypal) {
      let paypal;
      try {
        paypal = loadScript({
          "client-id": this.publicKeyPaypal,
        }).then(() => {
          this.setLoaded();
        });
      } catch (error) {}
    }
  }

  setLoaded() {
    const that = this;
    //@ts-ignore
    const paypal: any = window.paypal;
    let orderCodePaypal = "";
    let paymentMethodId = "";
    let amount = 0;
    const domain = this.$store.state?.product?.domain || "";
    //@ts-ignore
    window.paypal
      .Buttons({
        createOrder: async function (data: any, actions: any) {
          try {
            if (that.loadingPriceShipping) return;
            if (that.checkout.tip < 0)
              return that.$pushNotification.error("Tip cannot be less than 0");

            // checkCart(that);
            that.$gtag.event("payment_click_paypal", {
              event_category: "click paypal",
              event_label: "click paypal",
            });

            that.bodyPaypal = {
              shippingId: that.checkout?.shippingId,
              orderCode: that.checkout?.orderCode,
              payment: that.checkout?.payment,
              tip: that.checkout?.tip,
              // card: that.checkout?.card,
              // email: that.checkout?.shippingAddress?.email || "",
            };

            // if (!that.checkFieldBeforePayment()) {
            // } else {
            //   if (that.isSameAddress === "0") {
            //     that.checkout.billingAddress = {
            //       ...that.checkout.shippingAddress,
            //     };
            //   }
            //   that.bodyPaypal = that.checkout;
            //   if (!that.checkErrorField()) return;

            // }

            that.bodyPaypal.couponCode =
              that.checkout.couponCode || that.couponCode;
            that.$gtag.event("form_submissions", {
              value: `${that.listCart[0]?.productName || ""} ${
                that.totalPriceAll || 0
              }`,
              currency: "USD",
            });

            const bodyTrack = {
              productName: that.listCart[0]?.productName || "",
              currency: "USD",
              value: that.totalPriceAll || 0,
            };
            trackEventAddPaymentInfo(that, bodyTrack);
            // if (that.checkFieldBeforePayment()) {
            // }
            let cart = [...that.listCart];
            for (let elem of cart) {
              if (!elem.quantity || isNaN(elem.quantity)) {
                that.$pushNotification.error(
                  "Number of variants is invalid. Please re-add variant"
                );
                cart = that.listCart.filter(
                  (item: any) => !isNaN(item.quantity) && item.quantity > 0
                );
                that.$emit("update:listCart", cart);
                that.$emit("on-get-list");
                return;
              }
            }
            const listSelectedProduct = that.listCart.map((variant: any) => ({
              variantSellerId: variant._id,
              quantity: variant.quantity,
            }));
            let sessionId = getSessionId();
            if (!sessionId) {
              const charRandom = randomCharacter().toLocaleLowerCase();
              const unixTimeStamp = Math.floor(new Date().getTime() / 1000);
              sessionId = `${charRandom}_${unixTimeStamp}`;
              setSessionId(sessionId);
            }

            // if (that.bodyPaypal?.shippingAddress?.email) {
            //   that.bodyPaypal.shippingAddress.email =
            //     that.bodyPaypal.shippingAddress.email.toLowerCase();
            // } else {
            //   that.bodyPaypal.email = that.bodyPaypal.email.toLowerCase();
            // }

            // that.checkout.shippingAddress.email =
            //   that.checkout.shippingAddress.email.toLowerCase();

            // that.checkout.billingAddress.email =
            //   that.checkout.shippingAddress.email || "";

            // if (
            //   that.bodyPaypal?.shippingAddress?.state === "Choose your state"
            // ) {
            //   that.bodyPaypal.shippingAddress.state = "";
            // }
            // if (that.checkout?.billingAddress?.state === "Choose your state") {
            //   that.checkout.billingAddress.state = "";
            // }

            const body = {
              ...that.bodyPaypal,
              // ...that.bodyPaypal.shippingAddress,
              // billingAddress: that.$utils.compare(
              //   that.checkout.billingAddress,
              //   that.checkout.shippingAddress
              // )
              //   ? undefined
              //   : that.checkout.billingAddress,
              listSelectedProduct,
              countryIp: that.countryCodePayment,
              isAbandon: that.isAbandon,
            };
            const query = that.$store.state.sitePage.utm || {};
            const response = await that.$api.cart.checkout(
              body,
              domain,
              query,
              sessionId
            );
            if (response && response.data) {
              paymentMethodId = response.data.paymentMethodId;
              orderCodePaypal = response.data.orderCode;
              return response.data.id;
            }
          } catch (error: any) {
            console.log("error :>> ", error);
            const message = error?.response?.data?.message || "";
            that.$gtag.event("purchase fail", {
              error: message,
              product_id: that.listCart[0]?._id,
              event_label: "fail paypal",
            });
            that.$sentry.captureException(
              error.response?.data || "An error occurred"
            );
            apiErrorHandler(error, that);
          }
        },
        onApprove: async function (data: any, actions: any) {
          const { paymentID, payerID } = data;
          if (!paymentID || !payerID || !paymentMethodId) return;
          const response = await that.$api.cart.completePaypalPayment({
            paymentMethodId,
            paymentID,
            payerID,
          });
          if (response.data) {
            that.$gtag.event("purchase", {
              event_label: `purchase paypal`,
              currency: "USD",
            });
            const bodyTrack = {
              quantity: that.amount || 1,
              total: that.totalPriceAll || 1,
              productName: that.listCart[0]?.productName || "",
              listSelectedProduct: that.listCart.map((cart: any) => ({
                orderCode: response?.data?.orderCode || "",
                quantity: cart.quantity || 1,
                price: cart.price || 1,
              })),
              email: response?.data?.email || "",
              phoneNumber: response?.data?.phoneNumber || "",
              orderCode: response?.data?.orderCode || "",
            };
            trackEventPurchased(that, bodyTrack);
            that.$store.commit("cart/setListCart", []);
            localStorage.setItem("cart", JSON.stringify([]));
            that.$emit("update:isDonePayment", true);
            localStorage.setItem("tip", JSON.stringify(that.tip));
            that.$router.push(
              `${that.slug ? `/${that.slug}` : ""}/order-success?email=${
                response?.data?.email || ""
              }&order_code=${response.data.orderCode.replace("#", "")}`
            );
          }
        },
        //@ts-ignore
        onCancel: async function (isFail?: boolean) {
          Swal.fire({
            title: `Failed`,
            text: `Cancellation of payment successfully`,
            icon: "error",
            confirmButtonColor: "#FF5252",
            confirmButtonText: "Agree",
          });
          that.$gtag.event("cancel_click_paypal", {
            event_category: "click cancel paypal",
            event_label: "click cancel paypal",
          });
          // that.onDeleteOrder(orderCodePaypal);
          // that.$pushNotification.success(
          // 	`Cancellation of payment successfully`
          // );
        },
        fundingSource: that.enableCardPaypal
          ? undefined
          : paypal.FUNDING.PAYPAL,
      })
      //@ts-ignore
      .render(this.$refs.paypal);
  }

  async onDeleteOrder(orderCodePaypal: string) {
    try {
      this.$axios.setHeader(
        "secret",
        "RtV30HXkxzgdV3SX83XK4UuR7k2z9mtZ0Kxo1DYkHpt4CLF9gPM4u7ysa0cWIWwXqJUCSVut7gIouorFSrbVuejy5HghYdr9TQLm"
      );
      await this.$api.order.deleteOrder(orderCodePaypal);
    } catch (error) {}
  }

  checkFieldBeforePayment() {
    const { email, firstName, lastName, address, country, phoneNumber } =
      this.checkout.shippingAddress;
    if (!firstName && !lastName && !address && !phoneNumber) {
      return false;
    }

    return true;
  }

  resetField() {
    return {
      shippingAddress: {
        isEmail: "",
        isFirstName: "",
        isLastName: "",
        isAddress: "",
        isZipCode: "",
        isCity: "",
        isState: "",
        isPhoneNumber: "",
      },
      billingAddress: {
        isEmail: "",
        isFirstName: "",
        isLastName: "",
        isAddress: "",
        isZipCode: "",
        isCity: "",
        isState: "",
        isPhoneNumber: "",
      },
    };
  }

  checkErrorField() {
    try {
      const errorField: any = this.resetField();
      for (let item in this.checkout.shippingAddress) {
        let textFieldUppercase = `${
          item.charAt(0).toUpperCase() + item.slice(1)
        }`;
        if (item === "apartment") {
          continue;
        }
        if (
          item === "state" &&
          this.checkout.shippingAddress.country !== "United States" &&
          this.checkout.shippingAddress.country !== "Canada" &&
          this.checkout.shippingAddress.country !== "Australia"
        ) {
          continue;
        }
        if (
          !this.checkout.shippingAddress[item] ||
          this.checkout.shippingAddress[item] === "Choose your state"
        ) {
          if (item === "email") {
            errorField.shippingAddress[
              `is${textFieldUppercase}`
            ] = `"Email" is not allowed to be empty`;
          } else {
            errorField.shippingAddress[
              `is${textFieldUppercase}`
            ] = `Please fill this required field`;
          }
        } else {
          errorField.shippingAddress[`is${textFieldUppercase}`] = "";
        }
      }

      for (let item in this.checkout.billingAddress) {
        let textFieldUppercase = `${
          item.charAt(0).toUpperCase() + item.slice(1)
        }`;
        if (item === "apartment" || item === "email") {
          continue;
        }
        if (
          item === "state" &&
          this.checkout.billingAddress.country !== "United States" &&
          this.checkout.billingAddress.country !== "Canada" &&
          this.checkout.billingAddress.country !== "Australia"
        ) {
          continue;
        }
        if (
          !this.checkout.billingAddress[item] ||
          this.checkout.billingAddress[item] === "Choose your state"
        ) {
          if (item === "email") {
            errorField.billingAddress[
              `is${textFieldUppercase}`
            ] = `"Email" is not allowed to be empty`;
          } else {
            errorField.billingAddress[
              `is${textFieldUppercase}`
            ] = `Please fill this required field`;
          }
        } else {
          errorField.billingAddress[`is${textFieldUppercase}`] = "";
        }
      }

      this.$emit("update:errorField", errorField);
      for (let item in errorField.shippingAddress) {
        if (errorField.shippingAddress[item]) return false;
      }

      if (this.isSameAddress === "1") {
        for (let item in errorField.billingAddress) {
          if (errorField.billingAddress[item]) return false;
        }
      }
      return true;
    } catch (error) {
      console.log("error :>> ", error);
    }
  }

  get publicKeyPaypal() {
    return this.$store.state.cart.publicKeyPaypal;
  }

  get enableCardPaypal() {
    const listPayment = this.$store.state.cart?.listPayment || [];
    const findIndex = listPayment.findIndex(
      (payment: any) => payment.type === "paypal"
    );
    if (findIndex !== -1) {
      return listPayment[findIndex]?.isOpenPaypalCard;
    }
    return false;
  }
}
</script>

<style src="../style.scss" lang="scss" scoped></style>
